#include <stdio.h>
#include "z80-cpu.h"
#include "mini-display.h"
#include "keyboard.h"
#include "asm_interface.h"
#include "memory.h"
#ifdef  Z80_CTC
#include "hardware/z80-ctc.h"
#endif

#define TICS_PORT  (TICS_MEMO+TICS_WAIT)

static  FILE  *ports;

static int fd_out;
static int fd_in;


int
init_ports(void)
{
   char  buffer[256];
   fd_out=fileno(stdout);
   fd_in=fileno(stdin);
   ports= fopen(Z80_PORTS,"r+b");   /* read_writable_binary file */
   if (ports)
      if (256 != fread(buffer,1,256,ports))
      {  fclose(ports), ports= (FILE*)0;  }
   return !ports;
}


void
out_byte(unsigned char id, unsigned char data)
{
   if (id == fd_out)
      display_in_line(data);
   else if (ports)
   {  int i=fseek(ports,(long)id,SEEK_SET);
      if (i || 1 != fwrite(&data,1,1,ports))
         error(i,"hardware malfunction","port write:");
      fflush(ports);
#ifdef  Z80_CTC
      if (ctc_port(id))
         set_ctc_pin(ctc_rd,0);
#endif
      if (i=bank_port(id))
         switch_bank(data,i);
   }
   if (!cpu_pin[wait])  wait_tics(TICS_PORT);
#ifdef  Z80_CTC
   if (ports && ctc_port(id))
      set_ctc_pin(ctc_rd,1);
#endif
}

void
in_byte(unsigned char id, unsigned char *data)
{
   if (id == fd_in)
      keystrobe(data);
   else if (ports)
   {  int  i;  fflush(ports);
      i=fseek(ports,(long)id,SEEK_SET);
      if (i || 1 != fread(data,1,1,ports))
         error(i,"hardware malfunction","port read:");
   }
   if (!cpu_pin[wait])  wait_tics(TICS_PORT);
}
